#ifndef __MazeSolving_h__
#define __MazeSolving_h__

/*----- Node Structure -------------------------------------------------------*/
struct node
{
	uint8_t closed, open, visited;
	uint8_t posX, posY;
	uint8_t G, H;
	struct node *borders[4];
	struct node *parent;
};

/*----- Function Prototypes --------------------------------------------------*/
void 				initializeMazeSolver(void);
void 				updateIntersection(uint8_t);
uint8_t 		getNextMove(void);
void 				solvePath(void);
struct node *lowestOpenNode(void);
uint8_t 		openListIsEmpty(void);
void    		heuristic(uint8_t, uint8_t);
void    		clearPath(void);
uint8_t     turnRobot(uint8_t);
void        printOrientation(void);
void        printLocation(void);
void        printPath(void);
void        printNextMove(uint8_t);

#endif


