// Author: Clint Doriot

#include <inttypes.h>
#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include "LineTracking.h"
#include "LCD.h"
#include "ADC.h"
#include "servo.h"
#include "utils.h"
#include "MazeSolving.h"

/*----- Orientations ---------------------------------------------------------*/
#define UP      0x00
#define RIGHT   0x01
#define DOWN    0x02
#define LEFT    0x03
#define UNUSED  0x04

int main (void)
{
	adc_init();
	initializeLCD();
	initializeServos();
	initializeMazeSolver();


	uint8_t currentState = 0x01;
	
	do
	{
  	currentState = trackLine(currentState);
		currentState = debounceIntersection(currentState);
		
		printLineStatus(currentState);
		updateLineSpeed(currentState);
		
		currentState = turnRobot(currentState);
	}
	while(1);

	return 0;
}
