// Author: Clint Doriot
// Purpose: general utility functions used by several of the sub-systems

/*----- Includes -------------------------------------------------------------*/
#include <inttypes.h>
#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include "utils.h"

////////////////////////////////////////////////////////////////////////////////
// Name:   power
// Input:  x, y - x is the base, y is the exponant
// Output: x^y
// Action: computes and returns x^y for integers
////////////////////////////////////////////////////////////////////////////////
int power(int x, int y)
{
	int i;
	int returnInt = 1;
	for(i = 0; i < y; i++)
	  returnInt *= x;

	return returnInt;
}

////////////////////////////////////////////////////////////////////////////////
// Name:   delay_1us
// Input:  i - unsigned 8 bit integer specifying the delay in microseconds
// Output: None
// Action: Creates a delay of 'i' microseconds.
////////////////////////////////////////////////////////////////////////////////
void delay_1us(uint8_t i)
{
	uint8_t j;
	while ( i )
	{
		for (j=0 ; j<4 ; j++ );
			i--;
  }
}

////////////////////////////////////////////////////////////////////////////////
// Name:   delay_1ms
// Input:  i - unsigned 8 bit integer specifying the delay in milliseconds
// Output: None
// Action: Creates a delay of 'i' milliseconds.
////////////////////////////////////////////////////////////////////////////////
void delay_1ms(uint8_t i)
{
	uint8_t j, k;
	while ( i )
	{
		for (j=0 ; j<200 ; j++ )
		{
			for ( k=0 ; k < 2; k++);
		}
		i--;
	}
}

////////////////////////////////////////////////////////////////////////////////
// Name:   delay_100ms
// Input:  a - unsigned 8 bit integer specifying the delay in 100 milliseconds
// Output: None
// Action: Creates a delay of 'i'x100 milliseconds.
////////////////////////////////////////////////////////////////////////////////
void delay_100ms(uint8_t a)
{
	uint8_t i;
	for ( i=0; i<a; i++)
	{
		delay_1ms(100);
	}
}
